-- **************************************************************************
--   TitanPalsRightClick.lua
--
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanPals", true );

-- **************************************************************************
-- NAME : TitanPanelRightClickMenu_PreparePalsMenu()
-- DESC : Builds Right Click Interactive Menu
-- **************************************************************************
function TitanPanelRightClickMenu_PreparePalsMenu()
     --TitanPals_CoreUtils("UpDateBNIDS");
     local info = {};
     local NumPals, NumPalsO = GetNumFriends();
     local BNnumP, BNnumPo = BNGetNumFriends();
     local palsName, palsClass, givenName, realmName, surName, pID, fullName, toonID, BNI, BNToonCount, toonRealm, toonFaction, toonFactionID, fName, fNColor, toonName, toonClass, toonGame, toonNote, BNAFK, BNDND
     -- Start Menu 2
     if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then
          -- This is for whispering a friend
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_WHISPER"] ) then
               -- Normal Friends
               if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_WHISPER"], LB["TITAN_PALS_MENU_NORMAL"] ), UIDROPDOWNMENU_MENU_LEVEL ); end
               for BNI=1, NumPalsO do
                    palsName, _, palsClass = GetFriendInfo( BNI );
                    info = {};
                    info.text = TitanPals_ColorUtils( "GetCClass", palsClass, palsName );
                    info.func = palsWhisper;
                    info.value = palsName;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
               end
               -- Battle Net Friends
               if ( TitanPals.Settings.ShowBNTooltip and BNnumPo > 0 ) then 
                    if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL ); end
                    TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_WHISPER"], LB["TITAN_PALS_MENU_REALID"] ), UIDROPDOWNMENU_MENU_LEVEL );
                    for BNI = 1, BNnumPo do
	                 _, givenName, surName, _, toonID, toonGame, _, _, BNAFK, BNDND, _, TNote = BNGetFriendInfo( BNI );
                         fullName = ( "%s %s" ):format( givenName, surName );
                         BNToonCount = BNGetNumFriendToons( BNI );
                         for i = 1, BNToonCount do
                              _, toonName, _, realmName, _, _, _, toonClass, _, _, _, _ = BNGetFriendToonInfo( BNI, i );
                              info = {};
                              info.text = TitanPals_ColorUtils( "GetCClass", toonClass, ( "%s %s" ):format( BATTLENET_NAME_FORMAT:format( givenName, surName ), ( "( %s )" ):format( toonName ) ) );
                              info.func = palsWhisper;
                              info.value = BATTLENET_NAME_FORMAT:format( givenName, surName );
                              UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
			 end
                    end
               end
          end
          -- This is for group Invites
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_INVITE"] ) then
               -- Normal Friends
               if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_INVITE"], LB["TITAN_PALS_MENU_NORMAL"] ), UIDROPDOWNMENU_MENU_LEVEL ); end
               for BNI = 1, NumPalsO do
                    palsName, _, palsClass = GetFriendInfo( BNI );
                    info = {};
                    info.text = TitanPals_ColorUtils( "GetCClass", palsClass, palsName );
                    info.func = PalsInvite;
                    info.value = palsName;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
               end
               -- Battle Net Friends
               if ( TitanPals.Settings.ShowBNTooltip and BNnumPo > 0 ) then
                    if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL ); end
                    TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_INVITE"], LB["TITAN_PALS_MENU_REALID"] ), UIDROPDOWNMENU_MENU_LEVEL );
                    for BNI = 1, BNnumPo do
                         _, givenName, surName, toonName, toonID = BNGetFriendInfo( BNI );
                         BNToonCount = BNGetNumFriendToons( BNI );
                         for i = 1, BNToonCount do
                              toonRealm = select( 4, BNGetFriendToonInfo( BNI, i ) );
                              toonFactionID = select( 6, BNGetFriendToonInfo( BNI, i ) );
                              toonClass = select( 8, BNGetFriendToonInfo( BNI, i ) );
                              -- _, _, _, _, _, toonFactionID, _, toonClass = BNGetFriendToonInfo( BNI, i );
                              if ( toonFactionID == 0 ) then
                                   toonFaction = LB["TITAN_PALS_MENU_HORDE"];
                                   toonFactionBad = LB["TITAN_PALS_MENU_ALLIANCE"];
                                   fNColor = "|cffff4d4d";
                              elseif ( toonFactionID == 1 ) then
                                   toonFaction = LB["TITAN_PALS_MENU_ALLIANCE"];
                                   toonFactionBad = LB["TITAN_PALS_MENU_HORDE"];
                                   fNColor = "|cff4d4dff";
                              end
                              local fName = ( "%s%s-%s|r" ):format( fNColor, toonName, toonRealm );
                              fullName = ( "%s %s" ):format( BATTLENET_NAME_FORMAT:format( givenName, surName ), ( "( %s )" ):format( toonName ) )
                              info = {};
                              info.text = TitanPals_ColorUtils( "GetCClass", toonClass, fullName );
                              if ( toonFaction == ( "%s%s|r" ):format( fNColor, TitanPals.Profile.Faction ) ) then
                                   info.func = PalsInvite;
                                   info.value = ( "%s-%s" ):format( toonName, toonRealm )
                              else
                                   info.func = PalsFactionError;
                                   info.value = ( "%s:%s:%s" ):format( fName, toonFaction, toonFactionBad );
                              end
                              UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
                         end
                    end
               end
          end
          -- This is for setting friends note
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_NOTE"] ) then
               -- Normal Friends
               if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_NOTE"], LB["TITAN_PALS_MENU_NORMAL"] ), UIDROPDOWNMENU_MENU_LEVEL ); end
               for BNI = 1, NumPalsO do
                    palsName, _, palsClass = GetFriendInfo( BNI );
                    info = {};
                    info.text = TitanPals_ColorUtils( "GetCClass", palsClass, palsName );
                    info.func = PalsNotePopUp;
                    info.value = ( "Normal:pID:%s:%s" ):format( palsName, TitanPals_ColorUtils( "GetCClass", palsClass, palsName ) );
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
               end
               -- Battle Net Frineds
               if ( TitanPals.Settings.ShowBNTooltip and BNnumPo > 0 ) then
                    if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL ); end
                    TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_NOTE"], LB["TITAN_PALS_MENU_REALID"] ), UIDROPDOWNMENU_MENU_LEVEL );
                    for BNI = 1, BNnumPo do
                         pID, givenName, surName, toonName, toonID = BNGetFriendInfo( BNI );
                         _, _, _, _, _, _, _, BNClass = BNGetToonInfo( toonID );
                         fullName = format( BATTLENET_NAME_FORMAT, givenName, surName );
                         info = {};
                         info.text = TitanPals_ColorUtils( "GetCClass", BNClass, fullName );
                         info.func = PalsNotePopUp;
                         info.value = ( "BNet:%d:%s:%s" ):format( pID, fullName, TitanPals_ColorUtils( "GetCClass", BNClass, fullName ) );
                         UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
                    end
               end
          end
          -- This is for removing a friend from friends list
          if ( UIDROPDOWNMENU_MENU_VALUE == ( "|cffff2020%s|r" ):format( LB["TITAN_PALS_MENU_REMOVE"] ) ) then
               -- Remove Normal Friends
               if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_REMOVE"], LB["TITAN_PALS_MENU_NORMAL"] ), UIDROPDOWNMENU_MENU_LEVEL ); end
               for BNI = 1, NumPalsO do
                    palsName, _, palsClass = GetFriendInfo( BNI );
                    info = {};
                    info.text = TitanPals_ColorUtils( "GetCClass", palsClass, palsName );
                    info.func = PalsRemove;
                    info.value = palsName;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
               end
               -- Remove Battle Net Friends
               if ( TitanPals.Settings.ShowBNTooltip and BNnumPo > 0 ) then
                    if ( NumPalsO > 0 ) then TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL ); end
                    TitanPanelRightClickMenu_AddTitle( ( "%s %s" ):format( LB["TITAN_PALS_MENU_REMOVE"], LB["TITAN_PALS_MENU_REALID"] ), UIDROPDOWNMENU_MENU_LEVEL );
                    for BNI = 1, BNnumPo do
                         pID, givenName, surName, toonName, toonID = BNGetFriendInfo( BNI );
                         _, _, _, _, _, _, _, toonClass = BNGetToonInfo( toonID );
                         fullName = ( "%s %s ( %s )" ):format( givenName, surName, toonName );
                         info = {};
                         info.text = TitanPals_ColorUtils( "GetCClass", toonClass, fullName );
                         info.func = PalsBNRemove;
                         info.value = pID;
                         UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
                    end
               end
          end
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_SYNC"] ) then
	       TitanPanelRightClickMenu_AddTitle( LB["TITAN_PALS_MENU_SYNC"], UIDROPDOWNMENU_MENU_LEVEL );
               -- Sync Alts To Friends List Setting Option
               info = {};
               info.text = LB["TITAN_PALS_MENU_SYNCALTS"];
               info.func = TitanPanelPals_SyncAlts;
               UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
               -- Sync Alts To Friends List Setting Option
               info = {};
               info.text = LB["TITAN_PALS_MENU_SYNCALTSFRIENDS"];
               info.func = TitanPanelPals_SyncAltsFriends;
               UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
	  end
          --[[
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_CORE_DEBUG_HEADER"] ) then
                    TitanPanelRightClickMenu_AddTitle( LB["TITAN_PALS_CORE_DEBUG_DEBUG1"], UIDROPDOWNMENU_MENU_LEVEL );
                    info = {};
                    info.text = LB["TITAN_PALS_CORE_DEBUG_DEV"];
                    info.func = TitanPals_DevDebug;
                    info.checked = TitanPals.Debug.State;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
                    info = {};
                    info.text = LB["TITAN_PALS_CORE_DEBUG_DEVEVENT"];
                    info.func = TitanPals_DevDebugEvent;
                    info.checked = TitanPals.Debug.Event;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
                    info = {};
                    info.text = LB["TITAN_PALS_CORE_DEBUG_DEVLOGEVENT"];
                    info.func = TitanPals_DevDebugLogEvent;
                    info.checked = TitanPals.Debug.LogEvent;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
		    TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL );
		    TitanPanelRightClickMenu_AddTitle( LB["TITAN_PALS_CORE_DEBUG_PLAY"], UIDROPDOWNMENU_MENU_LEVEL );
		    info = {};
		    info.text = LB["TITAN_PALS_CORE_DEBUG_PLAYFRIENDS"];
		    info.func = TitanPals_MenuProssess;
		    info.value = "playFriends";
		    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
		    info = {};
		    info.text = LB["TITAN_PALS_CORE_DEBUG_PLAYALTS"];
		    info.func = TitanPals_MenuProssess;
		    info.value = "playAlts";
		    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
          end
          ]]--
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_REMOVEDATA"] ) then
	       TitanPanelRightClickMenu_AddTitle( LB["TITAN_PALS_MENU_REMOVEDATA"], UIDROPDOWNMENU_MENU_LEVEL );
	       -- Outdated Friends
               if ( NumPals > 0 ) then
                    info = {};
                    info.text = LB["TITAN_PALS_MENU_REMOVE_FRIEND"];
                    info.hasArrow = 1;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
               end
	       -- Outdated Alts
	       info = {};
	       info.text = LB["TITAN_PALS_MENU_REMOVE_ALT"];
	       info.hasArrow = 1;
	       UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
	  end
          return;
     end
     -- End Menu 2
     -- Start Menu 3
     if ( UIDROPDOWNMENU_MENU_LEVEL == 3 ) then
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_REMOVE_FRIEND"] ) then
               TitanPanelRightClickMenu_AddTitle( LB["TITAN_PALS_MENU_REMOVE_FRIENDDATA"], UIDROPDOWNMENU_MENU_LEVEL );
	       local a, b, c, n, v;
	       for n, v in pairs( TitanPals.Lists[palsDB] ) do
                    info = {};
                    info.text = LB["TITAN_PALS_MENU_SUB_REMOVE"]:format( TitanPals_ColorUtils( "GetCClass", v.Class, n ) );
                    info.value = ( "Lists:%s" )format( n );
                    info.func = TitanPals_MenuProssess;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
	       end
	  end
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_REMOVE_ALT"] ) then
	       TitanPanelRightClickMenu_AddTitle( LB["TITAN_PALS_MENU_REMOVE_ALTDATA"], UIDROPDOWNMENU_MENU_LEVEL );
	       local d, n, v;
               for n, v in pairs( TitanPals.Alts[palsDB] ) do
                    info = {};
                    info.text = LB["TITAN_PALS_MENU_SUB_REMOVE"]:format( TitanPals_ColorUtils( "GetCClass", v, n ) );
                    info.value = ( "Alts:%s" ):format( n );
                    info.func = TitanPals_MenuProssess;
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
	       end
	  end
          return;
     end
     -- End Menu 3
     TitanPanelRightClickMenu_AddTitle( TitanPlugins[ LB["TITAN_PALS_CORE_ID"] ].menuText );
     if ( NumPalsO > 0 or BNnumPo > 0 and TitanPals.Settings.ShowBNTooltip == true ) then
          info = {};
          info.text = LB["TITAN_PALS_MENU_WHISPER"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton( info );          -- create the title for the Whisper submenu
          info = {};
          info.text = LB["TITAN_PALS_MENU_INVITE"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton( info );          -- create the title for the Invite submenu
          info = {};
          info.text = LB["TITAN_PALS_MENU_NOTE"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton( info );          -- create the title for the Note submenu
          TitanPanelRightClickMenu_AddSpacer();
          info = {};
          info.text = ( ( "|cffff2020%s|r" ):format( LB["TITAN_PALS_MENU_REMOVE"] ) );
          info.hasArrow = 1;
          UIDropDownMenu_AddButton( info );          -- create the title for the Remove submenu
          TitanPanelRightClickMenu_AddSpacer();
     end
     info = {};
     info.text = LB["TITAN_PALS_MENU_SYNC"];
     info.hasArrow = 1;
     UIDropDownMenu_AddButton( info );     -- Syncing Alts / Alts Friends
     info = {};
     info.text = LB["TITAN_PALS_MENU_REMOVEDATA"]
     info.hasArrow = 1;
     UIDropDownMenu_AddButton( info );
     TitanPanelRightClickMenu_AddSpacer();     -- Removing Friends From Database
     --[[ Debuging Menu
     local TitanUser = TitanPals_CoreUtils( "Author", ( "%s@%s" ):format( TitanPals.Profile.Player, TitanPals.Profile.Realm ) );
     if ( TitanUser ) then 
          info = {};
          info.text = LB["TITAN_PALS_CORE_DEBUG_HEADER"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton( info );
          TitanPanelRightClickMenu_AddSpacer();
     end ]]--
     info = {};
     info.text = LB["TITAN_PALS_MENU_SETTINGS"];
     info.value = LB["TITAN_PALS_MENU_SETTINGS"];
     info.func = function() InterfaceOptionsFrame_OpenToCategory( LB["TITAN_PALS_ADDON_LABEL"] ); end
     UIDropDownMenu_AddButton( info );
     TitanPanelRightClickMenu_AddSpacer();
     -- Standard Menu
     TitanPanelRightClickMenu_AddToggleIcon( LB["TITAN_PALS_CORE_ID"] );
     TitanPanelRightClickMenu_AddToggleLabelText( LB["TITAN_PALS_CORE_ID"] );
     -- default Titan Panel right-click menu options
     TitanPanelRightClickMenu_AddCommand( L["TITAN_PANEL_MENU_HIDE"], LB["TITAN_PALS_CORE_ID"], TITAN_PANEL_MENU_FUNC_HIDE );
end

-- **************************************************************************
-- NAME : palsWhisper()
-- DESC : Opens a wisper with the selected person
-- **************************************************************************
function palsWhisper( self )
     if ( not ChatFrame1EditBox:IsVisible() ) then
          ChatFrame_OpenChat( ( "/w %s" ):format( self.value ) );
     else
          ChatFrame1EditBox:SetText( ( "/w %s" ):format( self.value ) );
     end
end

-- **************************************************************************
-- NAME : BNpalsWhisper()
-- DESC : Opens a wisper with the selected person
-- **************************************************************************
function BNpalsWhisper( self )
     BNSendWhisper( self.value, "" );
end

-- **************************************************************************
-- NAME : PalsRemove( self )
-- DESC : <research>
-- **************************************************************************
function PalsRemove( self )
     RemoveFriend( self.value );
end

-- **************************************************************************
-- NAME : PalsBNRemove( self )
-- DESC : <research>
-- **************************************************************************
function PalsBNRemove( self )
     BNRemoveFriend( self.value );
end

-- **************************************************************************
-- NAME : PalsInvite()
-- DESC : <research>
-- **************************************************************************
function PalsInvite( self )
     InviteUnit( self.value );
end

-- **************************************************************************
-- NAME : PalsNotePopUp()
-- DESC : <research>
-- **************************************************************************
function PalsNotePopUp( self )
     local a, b, c, d = string.match( self.value, "(.*):(.*):(.*):(.*)" );
     local array = {
          ["Type"] = a,
          ["pID"] = b,
          ["Player"] = c,
          ["PlayerColored"] = d,
     };
     TitanPanelPals_StaticPopup( array )
end

--[[ **************************************************************************
-- NAME : TitanPals_DevDebug( self )
-- DESC : <research>
-- **************************************************************************
function TitanPals_DevDebug( self )
     TitanPals.Debug.State = self.value;
     TitanPanelButton_UpdateButton( LB["TITAN_PALS_CORE_ID"] );
end

-- **************************************************************************
-- NAME : TitanPals_DevDebugEvent( self )
-- DESC : <research>
-- **************************************************************************
function TitanPals_DevDebugEvent( self )
     TitanPals.Debug.Event = self.value;
     TitanPanelButton_UpdateButton( LB["TITAN_PALS_CORE_ID"] );
end

-- **************************************************************************
-- NAME : TitanPals_DevDebugLogEvent( self )
-- DESC : <research>
-- **************************************************************************
function TitanPals_DevDebugLogEvent( self )
     TitanPals.Debug.LogEvent = self.value;
     TitanPanelButton_UpdateButton( LB["TITAN_PALS_CORE_ID"] );
end ]]--

-- **************************************************************************
-- NAME : PalsFactionError()
-- DESC : <research>
-- **************************************************************************
function PalsFactionError( self )
     local a, b, c = string.match( self.value, "(.*):(.*):(.*)" );
     local msg = LB["TITAN_PALS_FACTION_ERROR"]:format( a, b, c );
     TitanPals_DebugUtils( "error", "PalsFactionError", msg );
end

-- **************************************************************************
-- NAME : TitanPals_MenuProssess()
-- DESC : <research>
-- **************************************************************************
function TitanPals_MenuProssess( self )
     --[arg1   ]
     --[Command]
     local cmd = self.value;
     local a, b = string.match( cmd, "(.*):(.*)" );
     if ( a and b ) then
          TitanPals_CoreUtils( "fixDB", a, b );
     elseif ( cmd == "playFriends" or cmd == "playAlts" ) then
          TitanPals_CoreUtils( cmd );
     else TitanPals_DebugUtils( "bug", "MenuProssess", "Menu Prossessing failed." ); end
end